// Autor: Piotr Stefaczyk
// Data: 20161027
// Wersja: 20161027
// Program generacji zmodyfikowanego sygnau PWM na podstawie dekodowania wzorcowego sygnau PWM
// Realizuje funkcj serwa nieproporcjonalnego
// Wejcie PWM B3
// Wyjcie proporcjonalne PWM B2
// Wyjcie nieproporcjonalne 2 PWM B1
// Wyjcie nieproporcjonalne 1 PWM B0
// Kod przeznaczony do zastosowania na procesorze attiny13
// FUSEBITY
// L: 0x6A H: 0xFF LB: 0x3F
// Warunki uycia
// AUTOR UDZIELA LICENCJI DO ZASTOSOWA MODELARSKICH RC DLA CZONKW WIRTUALNEGO KLUBU MODELARSKIEGO
// www.alexrc.pl "LATANIE NA LUZIE" w zakresie:
// 1) prawa modyfikacji z zastrzeeniem e zmodyfikowany kod musi by rwnie publikowany na forum www.alexrc.pl z utrzymaniem warunkw licencji oryginau,
// 2) prawa uywania dla celw modelarskich w wersji niezmodyfikowanej lub zmodyfikowanej z zastrzeeniem wymogu spenienia punktu 1) powyej,
// 3) prawo okrelone w pkt 1) I pkt 2) udzielane jest pod warunkiem:
// a)przyjcia do wiadomoci i akceptacji faktu e kod jest udostpniany bez adnej gwarancji i publikujcy nie ponosi adnej odpowiedzialnoci z tytuu jego uycia, bdw lub innych form nieprawidowego dziaania,
// b)przyjcia do wiadomoci i akceptacji faktu e do uytkownika - licencjobiorcy naley zapewnienie e aplikacja w jakiej kod zostanie wykorzystany w czci lub caoci jest zgodna z bezwzgldnie obowizujcymi przepisami prawa w miejscu uycia.



.include "tn13def.inc"
.device ATtiny13 

// DEKLARACJE ZMIENNYCH ROBOCZYCH
.def temp1 = R17
.def temp2 = R16
.def temp3 = R18
.def temp4 = R19
.def temp5 = R20	

.cseg
.org 0x00

rjmp start

start:
// USTAWIENIE KONFIGURACJI PORTW
// B0 WYJCIE NIEPROPORCJONALNE PWM
// B1 WYJCIE NIEPROPORCJONALNE PWM
// B2 WYJCIE PROPORCJONALNE PWM (REPEATER)
// B3 WEJCIE PWM
ldi temp1, 0x07 
out DDRB,temp1
ldi temp1, 0x07
out PORTB,temp1


// WSTPNE USTAWIENIE GENERATORA PWM NA WARTO MINIMALN
// WARTOCI DOPUSZCZALNE WYPELNIENIA  MAX 0x29 MID 0x1B MIN 0x10
ldi temp1, 0x10  
out OCR0A,temp1
ldi temp1, 0x10 
out OCR0B,temp1

// USTAWIENIE TRYBU GENERATORA FAST PWM ORAZ CZSTOTLIWOCI/PRESCALER 64
ldi temp2, 0b10100011 //FAST PWM
out TCCR0A, temp2
ldi temp2, 0b00000011 //PRESCALER 
out TCCR0B,temp2

MAIN_LOOP:
// ZEROWANIE LICZNIKA DETEKTORA DUGOCI IMPULSU PWM
	ldi temp4, 0x00		

// OCZEKIWANIE NA POCZTEK IMPULSU CZYLI "1" NA WEJCIU PWM

waitfor1:
	in temp2, PINB		// pobieramy wejsciowy pin B
	sbrs temp2,3		// sprawdzamy czy bit 3 jes rowny 1
	rjmp waitfor1		// jesli nie to sprawdzamy jeszcze raz

// DETEKCJA DUGOSCI IMPULSU

pomiardlugosci:
	rcall delay_10u		// 10us opoznienia
	inc temp4			// naliczamy kwant dugoci
	in temp2, PINB		// pobieramy wejsciowy pin B
	sbrc temp2,3		// sprawdzamy czy bit 3 jes rowny 0
	rjmp pomiardlugosci	// jesli nie to liczymy dalej

	
// LICZNIK DETEKTORA temp4 ZAWIERA NIEZNORMALIZOWAN DUGO IMPULSU	
// WYZNACZANIE ZNORMALIZOWANEJ DUGOCI IMPULSU PWM DLA GENERATORA
	mov temp5, temp4	// zapisujemy robocz kopi wypenienia przed normalizacj
						// realizujemy normalizacj (temp5 - 89)/5 +13 
	subi temp5, 89		// skalujemy do 0
	cpi temp5,5			// bezpiecznik dolny rejestru tzn jeli jego warto jest mniejsza od 5 na potrzeby dzielenia binarnego
	brsh jestok			// warto wiksza od 5 pozwala skalowa
	ldi temp5,5			// warto mniejsza od 5 jest korygowana na 5

jestok:
	subi temp5, 5		// pierwszy krok dzielenia przez 5
	lsr temp5			// drugi krok dzielenia przez 5
	lsr temp5			// drugi krok dzielenia przez 5
	ldi temp1, 13		// skalujemy do progu wyjcia ustawienie 13
	add temp5, temp1

// REJESTR temp5 ZAWIERA WARTOS PROPORCJONALN (REPEATER DYSKRETNY O MNIEJSZEJ ROZDZIELCZOCI NI RDO)

// OPCJONALNY KOD DYSKRYMINATORA O ZADANYCH WARTOCIACH PROGOWYCH 
	cpi temp5,25			// Jeli dolny prg zadziaania dwigni "25" jest przekroczony 
	brsh jestok2			
	ldi temp5,0x10			// Ustawi warto minimaln pooenia serwa
	rjmp jestok4

jestok2:
	cpi temp5,32			// Jeli grny prg zadziaania dwigni "32" jest przekroczony 
	brlo jestok3			
	ldi temp5,0x29			// Ustawi warto maksymaln pooenia dwigni
	rjmp jestok4

jestok3:
	ldi temp5,0x1b			// Jeli warto mieci si pomidzy progami zachowa neutrum
// KONIEC KODU OPCJONALNEGO DYSKRYMINATORA
	

// USTAWIENIE WARTOSCI WYJ PWM 0 I 1 (BEZ LUB Z DYSKRYMINACJ)	
jestok4:
	mov temp1, temp5 // USTAWIENIE WYPELNIENIA  MAX 0x29 MID 0x1B MIN 0x10
	out OCR0A,temp1
	out OCR0B,temp1

// RCZNE WYBUDOWANIE IMPULSU PWM NA PORCIE B2	
	ldi temp1, 0x07		// Ustawi 1 na 2 3 - input (0,1 ignorowane) 
	out PORTB,temp1		// Wystawiamy na wyjcie "1"
odtwarzanie:
	rcall delay_10u		// 10us opoznienia
	nop					// kalibracja
	dec temp4			// zmniejszamy o 1 idc do 0
	cpi temp4, 0		// czy odtworzylismy impuls
	brne odtwarzanie	// jak nie to odtwarzamy dalej

	ldi temp1, 0x00		// Ustawi 0 na 2 3 - input (0,1 ignorowane) 
	out PORTB,temp1		// Wystawiamy na wyjcie "0"

// WARUNEK PONOWNEGO CYKLU CZYLI SPRAWDZENIE CZY NIE BIEGNIE JU IMPULS 	
// Sprawdzamy czy jest "0" Jeli nie to oczekujemy na "0"
waitfor0:
	in temp2, PINB		// pobieramy wejsciowy pin B
	sbrc temp2,3		// sprawdzamy czy bit 3 jes rowny 0
	rjmp waitfor0		// jesli nie to sprawdzaj jeszcze raz

// Jak mamy "0" to skaczemy do czekania na "1"
	rjmp MAIN_LOOP

// PROCEDURA OPӏNIAJCA
delay_10u: //10us

ret
	
